import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.stage.Stage;
import model.Monster;

import java.io.IOException;
import java.util.Random;

public class Main extends Application {

    @Override
    public void start(Stage primaryStage) throws IOException {
        FXMLLoader loader = new FXMLLoader(Main.class.getResource("gui.fxml"));
        BorderPane pane = loader.load();
        Scene scene = new Scene(pane);

        scene.getStylesheets().add(Main.class.getResource("style.css").toExternalForm());

        Monster arpos = new Monster(0, 0);
        arpos.watch(loader.getController());

        Thread thread = new Thread(() -> {
            Random random = new Random();
            while (true) {
                try {
                    // Wir simulieren hier, dass wir auf Events vom Server warten -- don't do this at home
                    Thread.sleep(2000 + random.nextInt(5000));
                } catch (InterruptedException e) {
                    throw new IllegalStateException("We overslept", e);
                }

                arpos.move((arpos.getX() + 1) % 2, 0);
            }
        });
        thread.setDaemon(true);
        thread.start();

        primaryStage.setTitle("GUI Demo");
        primaryStage.setScene(scene);
        primaryStage.show();
    }
    public static void main(String[] args) {
        launch(args);
    }
}























































