package controller;

import javafx.animation.TranslateTransition;
import javafx.fxml.FXML;
import javafx.geometry.Point2D;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.AnchorPane;
import javafx.scene.shape.Polygon;
import javafx.util.Duration;
import model.Monster;
import view.MonsterObserver;

public class Controller implements MonsterObserver {

    @FXML
    private Button button1;

    @FXML
    private Label label1;

    @FXML
    private AnchorPane pane;

    private final ImageView drache = new ImageView(new Image("arpos.gif"));

    @FXML
    private void onClick() {
        label1.setText("Hello World");
        button1.setVisible(false);
    }

    @FXML
    private void initialize() {
        // Startpunkt für Drachen
        Point2D f1 = new Point2D(200, 200);
        // Ein Paar Hexagons setzen
        pane.getChildren().addAll(drawHex(f1, "grass"), drawHex(new Point2D(400, 200), "trees"));
        // Drache positionieren
        drache.setTranslateX(f1.getX() - 75);
        drache.setTranslateY(f1.getY() - 75);
        // Drache richtig skalieren
        drache.setFitWidth(150);
        drache.setFitHeight(150);
        // Drachen auf das Panel setzen
        pane.getChildren().add(drache);

    }

    private static Polygon drawHex(Point2D center, String styleClass) {
        double x = center.getX();
        double y = center.getY();
        double[] points = new double[14];
        for (int i = 0; i < 12; i += 2) {
            double angle = Math.toRadians(i * 30);
            points[i] = x + Math.sin(angle) * 100d;
            points[i + 1] = y + Math.cos(angle) * 100d;
        }
        points[12] = points[0];
        points[13] = points[1];

        Polygon polygon = new Polygon(points);
        polygon.getStyleClass().add(styleClass);
        polygon.setStroke(null);
        return polygon;
    }

    @Override
    public void positionChanged(Monster monster) {
        int x = (monster.getX() + 1) * 200 - 75;
        int y = (monster.getY() + 1) * 200 - 75;

        TranslateTransition transition = new TranslateTransition(Duration.millis(700), drache);
        transition.setToX(x);
        transition.setToY(y);

        transition.play();
    }
}
