package model;

import view.MonsterObserver;

import java.util.ArrayList;
import java.util.Collection;

public class Monster {

    private int x;
    private int y;
    private final Collection<MonsterObserver> observers = new ArrayList<>(8);

    public Monster(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }


    public void move(int x, int y) {
        this.x = x;
        this.y = y;
        for (MonsterObserver observer : observers) {
            observer.positionChanged(this);
        }
    }

    public void watch(MonsterObserver observer) {
        observers.add(observer);
    }

}
































































































/*
public class Monster {

    private int x;
    private int y;
    private final Collection<MonsterObserver> observers = new ArrayList<>(5);

    public Monster(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }

    public void watch(MonsterObserver observer) {
        observers.add(observer);
    }

    public void move(int x, int y) {
        this.x = x;
        this.y = y;
        for (MonsterObserver observer : observers) {
            observer.positionChanged(this);
        }
    }

}
 */




/*

public interface MonsterObserver {

    void positionChanged(Monster m);

}

 */